image: python:latest

stages:
  - install
  - review
  - test
  - build
  - publish
  - document

cache:
  paths:
    - venv/

before_script:
  - make setup-virtualenv
  - source venv/bin/activate
  - pip install --upgrade pip
  - make prepare-dev-env

install_dev:
  stage: install
  script:
    - make install-dev-deps

install_prod:
  stage: install
  script:
    - make install

build:
  stage: build
  script:
    - make create_wheel
  artifacts:
    paths:
      - dist/*.whl

publish:
  stage: publish
  variables:
    TWINE_USERNAME: $PYPI_USERNAME
    TWINE_PASSWORD: $PYPI_PASSWORD
  script:
    - pip install twine
    - make publish
  only:
    - tags
